﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace howto_use_json
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Make an object to serialize.
            Customer cust = new Customer()
            {
                Name = "Rod Stephens",
                Street = "1337 Leet St",
                City = "Bugsville",
                State = "CA",
                Zip = "98765",
                PhoneNumbers = new Dictionary<string, string>()
                {
                    {"Home", "111-222-3333"},
                    {"Cell", "222-333-4444"},
                    {"Work", "333-444-5555"},
                },
                EmailAddresses = new List<string>()
                {
                    "somewhere@someplace.com",
                    "nowhere@noplace.com",
                    "root@everywhere.org",
                },
            };
            cust.Orders = new Order[3];
            cust.Orders[0] = new Order()
            {
                Description = "Pencils, dozen",
                Quantity = 10,
                Price = 1.13m
            };
            cust.Orders[1] = new Order()
            {
                Description = "Notepad",
                Quantity = 3,
                Price = 0.99m
            };
            cust.Orders[2] = new Order()
            {
                Description = "Cookies",
                Quantity = 1,
                Price = 3.75m
            };

            // Display the serialization.
            string serialization = cust.ToJson();
            txtJson.Text = serialization;
            txtJson.Select(0, 0);
            
            // Deserialize.
            Customer new_cust = Customer.FromJson(serialization);
            txtProperties.Text = new_cust.ToString();
            txtProperties.Select(0, 0);
        }
    }
}
